/* ==( bench/chain.c )== */
/* ----------------------------------------------- */
/* Pro-C  Copyright (C) 1988 - 1990 Vestronix Inc. */
/* Modification to this source is not supported    */
/* by Vestronix Inc.                               */
/*            All Rights Reserved                  */
/* ----------------------------------------------- */
/* Written   Geo  26-Aug-88                        */
/* Modified  Geo   4-Oct-89  See comments below    */
/* ----------------------------------------------- */
/* %W%  (%H% %T%) */

/*
 *  Modifications
 *
 *   3-Jan-90  SBF - V2 version with more varargs (#define NUMVAS)
 *   2-Jan-90  JZ  - V2 version with varargs
 *   4-Nov-89  Geo - V2 version with just 1 arg
 *  25-Oct-89  Geo - 1.32 Merge
*/

# include <stdio.h>
# include <bench.h>

# define NUMVAS 16

/* Chain to another program */
# ifdef UNIX
void chain(va_alist)
va_dcl
# else
void chain(char *va_alist, ...)
# endif
{
	va_list ap;
	char *args[NUMVAS + 1];   /* allow for NULL termination */
	char *this_arg;
	int argno;

# ifdef UNIX 
	va_start(ap);
	this_arg = va_arg(ap, char *);
# else
	va_start(ap, va_alist);
	this_arg = va_alist;
# endif

	for (argno = 0; argno < (NUMVAS + 1); argno++)
	{
		args[argno] = this_arg;
		if (this_arg == NULL)
			break;
		this_arg = va_arg(ap, char *);
	}

	va_end(ap);

/*
 * I hope you're not getting this message,
 * because if you are you're passing too
 * many args!!!
*/
	if (argno == (NUMVAS + 1))
	{
		errmsg("var arg overflow in chain()...");
		args[NUMVAS] = NULL;
	}

	chainv(args);
}

/*
 * Chain to another program using array of args to pass on to execvp
 * (this is the one that really does the work)
 */
void chainv(args)
char **args;
{
	closefall(); /* Reduce Number of OPENF files */

# ifdef MOUSE
	mouse_cursor(OFF);
	mouse_delete_level(0);
# endif

	/* If NAME is NULL, then STOP the chaining mechanism */
	if (args != NULL && *args != NULL && **args != '\0') 
	{
		end_w(FALSE);

		execvp(args[0], args);

		/* Only can get here if execvp failed */
		fprintf(stderr, "\nError EXECing %s\n", args[0]);
		fprintf(stderr, "\nPress Return "); fflush(stderr);
		getchar();

		/* User perror or something - GEO */
		exit(1);
	}

# ifdef MOUSE
	mouse_end();
# endif

	end_w(TRUE);
	exit(0);
}

