/* ==( bench/iosup.c )== */

/* ----------------------------------------------- */
/* Pro-C - Copyright (C) 1988, 1989 Vestronix Inc. */
/* Modification to this source is not supported    */
/* by Vestronix Inc.                               */
/*            All Rights Reserved                  */
/* ----------------------------------------------- */

/* ---   D R A F T   V E R S I O N   --- */


/*****************************************************************************
 *                 I/O Library  -  General Support Functions                 *
 *****************************************************************************
 *                                                                           *
 *  This module contains small support functions used by various specific    *
 *  I/O managers, for length checks, string truncation etc.  Ultimately      *
 *  these might be replaced with finalized WorkBench library functions.      *
 *                                                                           *
 *  Written  :                                                               *
 *  Date     :                                                               *
 *  Modified :                                                               *
 *                                                                           *
 *****************************************************************************/

#include <stdio.h>
#include <string.h>

/****************************************************************************/
/*                         Function Prototypes                              */
/****************************************************************************/

#ifdef MSDOS
#define ANSI
#endif

#ifdef ANSI
void stripright(char *, int);
int  nummasklen(char *);
int  decmasklen(char *);
#else
void stripright();
int  nummasklen();
int  decmasklen();
#endif


/*****************************************************************************/
/*                               Functions                                   */
/*****************************************************************************/


void stripright(str, slen)              /* strip up to slen trailing spaces */
char *str;
int slen;
{
   int i;
   for (i = slen-1; (i >= 0) && (str[i] == ' ') ; i--)
      str[i]='\0';
}


int nummasklen(msk)             /* numerical field length including decimal */
char *msk;
{
   int n, leng = 0;

   for (n = 0; n < strlen(msk); n++)
      if ((msk[n] == 'z') || (msk[n] == 'Z') || (msk[n] == '9') || 
          (msk[n] == '.') || (msk[n] == '$'))
         leng++;
   return(leng);
}


int decmasklen(msk)                    /* decimal places in numerical field */
char *msk;
{
   int n, leng = 0;
   char *decpart;

   decpart = strchr(msk, '.');
   if (!decpart)
      return(0);
   for (n = 0; n < strlen(decpart); n++)
      if ((decpart[n] == 'z') || (decpart[n] == 'Z') || (decpart[n] == '9'))
         leng++;
   return(leng);
}

